--[[
LuckyCharms2 r37
Last Changed By: neer
Last Changed: 2011-01-22T10:07:27Z
]]

--Locals
local LC2_Realm = GetCVar("realmName"); --Get Realm for Profile.
local LC2_Char = UnitName("player"); --Get char name for profile.
local LC2Profile = LC2_Realm.." - "..LC2_Char;

LuckyCharms.Flares.Config = {};

function LuckyCharms.Flares.Config.OnLoad(panel)
	panel.name = LC2Txt_WMBar.." "..LC2Txt_Conf;
	panel.parent = "LuckyCharms2";
	InterfaceOptions_AddCategory(panel); 

	LuckyCharmFlaresConfig_Title:SetText(LC2Name.." "..LC2Version);
	LuckyCharmFlaresConfig_SubTitle:SetText("|cFFFFFFFF"..LC2Txt_WMBar.." "..LC2Txt_Conf.."|r");
	LuckyCharmFlaresConfig_Scale:SetText(LC2Txt_WMBar.." "..LC2Txt_Scale..":\n"..CHAT_DEFAULT..": |cFF4DBD331.0|r");
	LuckyCharmFlaresConfig_Alpha:SetText(LC2Txt_WMBar.." "..OPACITY..":\n"..CHAT_DEFAULT..": |cFF4DBD331.0|r");
	LuckyCharmFlaresConfig_FlareDisplay:SetText(LC2Txt_WMBar.." "..DISPLAY..":\n"..CHAT_DEFAULT..": |cFF4DBD33"..LC2Txt_Auto.."|r");
	LuckyCharmFlaresConfig_WMShowText:SetText("|cFFFFFFFF"..LC2Txt_Shown.."|r");
	LuckyCharmFlaresConfig_WMHideText:SetText("|cFFFFFFFF"..LC2Txt_Hidden.."|r");
	LuckyCharmFlaresConfig_WMAutoText:SetText("|cFFFFFFFF"..LC2Txt_Auto.."|r");
	LuckyCharmFlaresConfig_FlareOrientation:SetText(LC2Txt_WMBar.." "..LC2Txt_Orientation..":\n"..CHAT_DEFAULT..": |cFF4DBD33"..LC2Txt_Horizontal.."|r");
	LuckyCharmFlaresConfig_WMHorizontalText:SetText("|cFFFFFFFF"..LC2Txt_Horizontal.."|r");
	LuckyCharmFlaresConfig_WMVerticalText:SetText("|cFFFFFFFF"..LC2Txt_Vertical.."|r");
	LuckyCharmFlaresConfig_ButtonSpacing:SetText(LC2Txt_WMBar.." "..LC2Txt_ButtonSpacing..":\n"..CHAT_DEFAULT..": |cFF4DBD330|r");
end

function LuckyCharms.Flares.Config.WMRadio(status,startup)
	if(status == "show") then
		LuckyCharmFlaresConfig_WMShow:SetChecked(1);
		LuckyCharmFlaresConfig_WMHide:SetChecked(nil);
		LuckyCharmFlaresConfig_WMAuto:SetChecked(nil);
	elseif(status == "hide") then
		LuckyCharmFlaresConfig_WMShow:SetChecked(nil);
		LuckyCharmFlaresConfig_WMHide:SetChecked(1);
		LuckyCharmFlaresConfig_WMAuto:SetChecked(nil);
	else
		LuckyCharmFlaresConfig_WMShow:SetChecked(nil);
		LuckyCharmFlaresConfig_WMHide:SetChecked(nil);
		LuckyCharmFlaresConfig_WMAuto:SetChecked(1);
	end
	if(startup == 0) then
		if(status == "show") then
			LuckyCharmsFlares_main:Show();
		elseif(status == "auto") then
			if(IsRaidOfficer() or IsRaidLeader() or UnitIsPartyLeader("player")) then
				if(not LuckyCharmsFlares_main:IsShown()) then
					LuckyCharmsFlares_main:Show();
				end
			else
				if(LuckyCharmsFlares_main:IsShown()) then
					LuckyCharmsFlares_main:Hide();
				end
			end
		else
			LuckyCharmsFlares_main:Hide();
		end
		LC2_Settings[LC2Profile].wmbarstatus = status;
	end
	--LuckyCharms.Message(LC2_Settings[LC2Profile].wmbarstatus);--Debug
end

function LuckyCharms.Flares.Config.WMRadioOrient(status,startup)
	if(status == "h") then
		LuckyCharmFlaresConfig_WMHorizontal:SetChecked(1);
		LuckyCharmFlaresConfig_WMVertical:SetChecked(nil);
	else
		LuckyCharmFlaresConfig_WMHorizontal:SetChecked(nil);
		LuckyCharmFlaresConfig_WMVertical:SetChecked(1);
	end
	if(startup == 0) then
		LuckyCharms.Flares.SetButtonPoints(status);
		LC2_Settings[LC2Profile].FlareBarOrient = status;
	end
end

function LuckyCharms.Flares.Config.InitScaleSlider(slider)
	slider:SetValue(LC2_Settings[LC2Profile].FlareBarScale);
end

function LuckyCharms.Flares.Config.InitAlphaSlider(slider)
	slider:SetValue(LC2_Settings[LC2Profile].FlareBarAlpha);
end

function LuckyCharms.Flares.Config.ModAlpha(value)
	LC2_Settings[LC2Profile].FlareBarAlpha = value;
	LuckyCharmsFlares_main:SetAlpha(value);
	LuckyCharmFlaresConfig_SliderAlpha:SetValue(value);
end

function LuckyCharms.Flares.Config.ModScale(value)
	LC2_Settings[LC2Profile].FlareBarScale = value;
	LuckyCharmsFlares_main:SetScale(value);
	LuckyCharmFlaresConfig_SliderScale:SetValue(value);
end

function LuckyCharms.Flares.Config.SliderScaleChange(slider)
	local sl = _G[slider];
	local newVal = string.format("%.1f",sl:GetValue());
	_G[slider .. "Text"]:SetText(newVal);
	LuckyCharms.Flares.Config.ModScale(newVal);
end

function LuckyCharms.Flares.Config.SliderAlphaChange(slider)
	local sl = _G[slider];
	local newVal = string.format("%.1f",sl:GetValue());
	_G[slider .. "Text"]:SetText(newVal);
	LuckyCharms.Flares.Config.ModAlpha(newVal);
end

--Button spacing slider
function LuckyCharms.Flares.Config.InitSliderButtonSpacing(slider)
	slider:SetValue(LC2_Settings[LC2Profile].FlareBarSpacing);
end

function LuckyCharms.Flares.Config.SliderButtonSpacingChange(slider)
	local sl = _G[slider];
	local newVal = string.format("%.1f",sl:GetValue());
	_G[slider .. "Text"]:SetText(newVal);
	LC2_Settings[LC2Profile].FlareBarSpacing = newVal;
	--slider:SetValue(newVal);
	LuckyCharms.Flares.SetButtonPoints(LC2_Settings[LC2Profile].FlareBarOrient);
end
--End Button spacing slider